Bug 40493 - Invalid IL when using ?. operator on a Func<T> parameter in a generic function when T is unconstrained
Summary: Invalid IL when using ?. operator on a Func<T> parameter in a generic functi...
Status: RESOLVED FIXED
Alias: None
Product: Compilers
Classification: Mono
Component: C# (show other bugs)
Version: 4.2.0 (C6)
Hardware: PC Linux
: --- normal
Target Milestone: ---
Assignee: Marek Safar
URL:
Depends on:
Blocks:
 
Reported: 2016-04-18 19:56 UTC by Michał Przybyś
Modified: 2016-04-20 12:33 UTC (History)
1 user (show)

Tags:
Is this bug a regression?: ---
Last known good build:

Notice (2018-05-24): bugzilla.xamarin.com is now in read-only mode.

Please join us on Visual Studio Developer Community and in the Xamarin and Mono organizations on GitHub to continue tracking issues. Bugzilla will remain available for reference in read-only mode. We will continue to work on open Bugzilla bugs, copy them to the new locations as needed for follow-up, and add the new items under Related Links.

Our sincere thanks to everyone who has contributed on this bug tracker over the years. Thanks also for your understanding as we make these adjustments and improvements for the future.


Please create a new report on GitHub or Developer Community with your current version information, steps to reproduce, and relevant error messages or log files if you are hitting an issue that looks similar to this resolved bug and you do not yet see a matching new report.

Related Links:
Status:
RESOLVED FIXED

Description Michał Przybyś 2016-04-18 19:56:13 UTC
The following code is compiled by mcs and throws an InvalidProgramException when run:

using System;

static class Program
{
    static void Bug<T>(Func<T> func)
    {
        Console.WriteLine(func?.Invoke());
    }
    
    static void Main()
    {
        Bug(() => 123);
    }
}

csc from VS2015 on the other hand returns error "CS0023: Operator '?' cannot be applied to operand of type 'T'" unless there is a constraint on T.

Reproduced both on Ubuntu with mono 4.2.3.4 and FreeBSD with mono 4.2.2.10.
Comment 1 Marek Safar 2016-04-20 12:33:33 UTC
Fixed in master and 4.5 preview